#ifndef __PLATFORM_NARF52_NARF52_GPIO_H__
#define __PLATFORM_NARF52_NARF52_GPIO_H__

#include <stdint.h>

enum narf52_gpio_direction {
    NARF_GPIO_DIR_IN = 0,
    NARF_GPIO_DIR_OUT
};

enum narf52_gpio_pin_input {
    NARF_GPIO_PIN_INPUT_CONNECT    = 0,   ///< Connect input buffer.
    NARF_GPIO_PIN_INPUT_DISCONNECT        ///< Disconnect input buffer.
};

enum narf52_gpio_pin_pull {
    NARF_GPIO_PIN_NOPULL   = 0,  ///<  Pin pull-up resistor disabled.
    NARF_GPIO_PIN_PULLDOWN = 1,  ///<  Pin pull-down resistor enabled.
    NARF_GPIO_PIN_PULLUP   = 3   ///<  Pin pull-up resistor enabled.
};

enum narf52_gpio_pin_drive {
    NARF_GPIO_PIN_S0S1 = 0,  ///< !< Standard '0', standard '1'.
    NARF_GPIO_PIN_H0S1 = 1,  ///< !< High-drive '0', standard '1'.
    NARF_GPIO_PIN_S0H1 = 2,  ///< !< Standard '0', high-drive '1'.
    NARF_GPIO_PIN_H0H1 = 3,  ///< !< High drive '0', high-drive '1'.
    NARF_GPIO_PIN_D0S1 = 4,  ///< !< Disconnect '0' standard '1'.
    NARF_GPIO_PIN_D0H1 = 5,  ///< !< Disconnect '0', high-drive '1'.
    NARF_GPIO_PIN_S0D1 = 6,  ///< !< Standard '0', disconnect '1'.
    NARF_GPIO_PIN_H0D1 = 7   ///< !< High-drive '0', disconnect '1'.
};

enum narf52_gpio_pin_sense {
    NARF_GPIO_PIN_NOSENSE    = 0,    ///<  Pin sense level disabled.
    NARF_GPIO_PIN_SENSE_LOW  = 1,    ///<  Pin sense low level.
    NARF_GPIO_PIN_SENSE_HIGH = 2     ///<  Pin sense high level.
};

struct narf52_gpio {
    uint32_t pin_number;
    enum narf52_gpio_direction dir;
    enum narf52_gpio_pin_input input;
    enum narf52_gpio_pin_pull pull;
    enum narf52_gpio_pin_drive drive;
    enum narf52_gpio_pin_sense sense;
};

#endif
